/*
 Serial messages (4) : Serial Event et commande avec un argument
 Les données série reçues sont des octets qui ont la meme taille qu'un caractère (8 bits).
 On ajoute ces données les unes aux autres (on dit "concatèner") pour former une chaine de caractères (String). 
 Quand le caractère équivalent au retour de ligne (\n ou 10 en ASCII) est reçue alors on affiche la chaine de caractères.
*/

String inputString = "";   // chaine de caractères pour contenir les données
boolean stringComplete = false;  // pour savoir si la chaine est complète
String fct ="";
String arg="";
int index;

void setup() {
  Serial.begin(9600);     // port série
  pinMode(13,OUTPUT);
  pinMode(9,OUTPUT);
}

void loop() {
  if (stringComplete) {
    //Serial.println(inputString); 
    index = inputString.indexOf(' '); // on récupère la position du séparateur (l'espace " ")
    fct = inputString.substring(0,index); // on coupe la chaine en deux : la fonction et l'argument
    arg = inputString.substring(index,inputString.length());
    
    if (fct == "LED13") {
      light(13, arg.toInt()); // appel de ma fonction en transformant la chaine en nombre
    }
    else if (fct == "LED9") {
      light(9, arg.toInt());
    }

    inputString = "";            // vide la chaine
    stringComplete = false;
  }
}

/*
  SerialEvent est déclenché quand de nouvelles données sont reçues. 
  Cett routine tourne entre chaque loop(), donc utiliser un delay la fait aussi attendre
 */
void serialEvent() {
  while (Serial.available()) {
    char inChar = (char)Serial.read(); // Récupérer le prochain octet (byte ou char)
    inputString += inChar; // concaténation des octets
    if (inChar == '\n') {  // caractère de fin pour notre chaine
      stringComplete = true;
    }
  }
}

// fonction personnalisable
void light(int pin, int brightness) {
  Serial.print("Light function : ");
  Serial.print(pin);
  Serial.print(" , ");
  Serial.println(brightness);
  analogWrite(pin,brightness);
}

